/*
///////////////////////////////////////////////////////////////////////////////////////////////////
//shnQ@sb`mvO
//	FileName	demo.c
//	Version		1.00
//	MCU		H8/36057
//	Work		
//-------------------------------------------------------------------------------------------------
//
//	2007/04/05	Ver1.00
//-------------------------------------------------------------------------------------------------
//ldln
//	sb`m𓮍삳vOłB
//	demo1.motdemo2.mot񂾃{[hmőMs܂B
//	Mf[^͂rbhɂďo͂܂B
//-------------------------------------------------------------------------------------------------
*/

/*

̃\tgEFA̓t[EFAłB

̃\tgEFAɊւ鎿ɂ܂ẮA
T|[g̑ΏۊOƂȂ܂B

쌠͍쐬ł()kldqL̂Ƃ܂B

̃\tgEFAgpƂɂSĂ̑QɂāA
쐬͈؂̐ӔC𕉂Ȃ̂Ƃ܂B

̃\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ
֎~܂BGȂǂ֏ЉE^̏ꍇ͘A肢v
܂B

@Copyright (C) Hokuto denshi Co,Ltd. 2007

*/


/*
/////////////////////////////////////////////////////////////////////////////////////////
//CN[ht@C錾
*/
#include "36057f.h"
#include <machine.h>


/*
/////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/
#define VAL_LCD_ROW		16	/* ő */
#define VAL_LCD_COLUMN		2	/* cő */

#define VAL_RS_LOW		0x00
#define VAL_RS_HIGH		0x01

/* G[R[h */
#define NOERROR			0

/*
/////////////////////////////////////////////////////////////////////////////////////////
//^錾
*/
typedef struct typeLCD
{
	union 
	{
		struct 
		{
			unsigned char X : 4;
			unsigned char Y : 4;
		} BIT;
		unsigned char BYTE;
	} CURSOR;
} TYPE_STRUCT_LCD;

/*
/////////////////////////////////////////////////////////////////////////////////////////
//ϐ錾
*/
static TYPE_STRUCT_LCD m_LCDInfo;		/* kbc */

/*
//////////////////////////////////////////////////////////////////////////////////////////
//֐vg^Cv錾
*/
extern void reset( void );

void Main( void );
void Wait( const unsigned int msec );
int Port_Init( void );

/* SCI */
int SCI_Init( void );
int SCI_Write( const unsigned char data );
unsigned char SCI_Read( void );
int SCI_Print( char *data );
int SCI_Print_Hex_Byte( const unsigned char data );

/* LCD */
int Init_LCD ( void );
int Clear_LCD ( void );
int Locate_LCD ( const unsigned char X, const unsigned char Y );
int Print_LCD ( const char *String );
int Write_LCD ( const unsigned char RS_Mode , const unsigned char Data );
void Wait_LCD ( const unsigned long Interval );

/* TinyCAN */
int TinyCAN_Init ( void );
int TinyCAN_Write ( void );
int TinyCAN_Read ( void );


/*
//////////////////////////////////////////////////////////////////////////////////////////
//萔錾
*/

const char *m_Str1 = "Tiny I/O 2 CAN\nSAMPLE PROGRAM";


/*
///////////////////////////////////////////////////////////////////////////////
//reset
//E
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void reset( void )
{
	set_imask_ccr( 0 );
	_INITSCT();
	Main();
	sleep();
}

/*
///////////////////////////////////////////////////////////////////////////////
//Main
//EC
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Main( void )
{
	Port_Init();
	SCI_Init();
	

	Init_LCD();
	TinyCAN_Init();

	SCI_Print( "\n<< H8Tiny CAN Demo Program >>\n" );

	Print_LCD ( m_Str1 );
	
	while(1)
	{
		TinyCAN_Write();
		TinyCAN_Read();
	}
}


/*
///////////////////////////////////////////////////////////////////////////////
//Port_Init
//E|[g
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Port_Init( void )
{
	*PCR6 = 0xff;		/* Port-6 Output Set */
	*PDR6 = 0x00;		/* Port-6 0x00 Output */
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//TinyCAN_Init
//ETinyCAN
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int TinyCAN_Init ( void )
{
	int i,j;
	
	/* Zbg̏ */
	*MCR =  0x00;			/* RSTRQ0ɃNA */
	
	*TCIRR0 = *TCIRR0 & ~0x01;	/* TCIRR0RHI0ɃNA */
	
	/* TCIMR̕Kvȃrbg0NA */
	*TCIMR0 = 0xff;
	*TCIMR1 = 0xff;
	
	*MBIMR = 0xff;			/* e[{bNX̊荞ݗv֎~ */
	
	/* [{bNX̐ݒ */
	*MBCR = 0x01;			/*MB3Mp{bNX@MB0Mp{bNX*/
	
	
	/* bZ[WRg[ */
	for(i=0;i<=24 ;i+=8)
	{
		*( MC0_0 + i ) = 0x00;			/* MC0_1,MC1_1,MC2_1,MC3_1 */
	}
	for(i=0; i<=24; i+=8)
	{
		for(j=0; j<5; j++)
		{
			*( MC0_4 + i + j ) = 0x00;	/* MC0_4`7,MC1_4`7,MC2_4`7,MC3_4`7 */
		}
	}
	
#ifdef mast
	/* Demo1.motp̐ݒ */
	
	/* Mݒ */
	*MC3_0 = 0x08;		/* đM f[^8oCg */
	*MC3_4 = 0x80;		/* X^_[hID = 00000000100 */
	
	/* Mݒ */
	*MC0_0 = 0x08;		/* đM f[^8oCg */
	*MC0_4 = 0x40;		/* X^_[hID = 00000000010 */
	
#else 
	/* Demo2.motp̐ݒ */
	
	/* Mݒ */
	*MC3_0 = 0x08;		/* đM f[^8oCg */
	*MC3_4 = 0x40;		/* X^_[hID = 00000000010 */
	
	/* Mݒ */
	*MC0_0 = 0x08;		/* đM f[^8oCg */
	*MC0_4 = 0x80;		/* X^_[hID = 00000000100 */
	
#endif
	
	/* LAFM([JANZv^XtB^}XN)  */
	for(i=0;i<16 ;i++)
	{
		*( LAFML0_1 + i ) = 0x00;	/*LAFM3`0_0`4*/
	}

	/* MD(bZ[Wf[^)  */
	for(i=0;i<32 ;i++)
	{
		*( MD0_1 + i ) = 0x00;		/*MD3`0_1`8*/
	}
	
	*TCMR = 0x03;		/* P97 = HTXD , P96 = HRXD ɐݒ */
	
	*BCR0 = 0x01;		/* =20MHz SJW=1 BSP=1 */
				/* őrbg 1time quantum A2~VXeNbN */
	*BCR1 = 0x33;		/* BRP=2 TSEG1=4 TSEG2=4 */
				/* 011FPHSEG24time quanta 0011FPRSEG + PHSEG14time quanta	*/

	/* GSRRESET = 0ɂȂ܂Ń[v */
	while ( ( *GSR & 0x08 ) == 1 ){
		Wait ( 1 );
	}
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//TinyCAN_Write
//ETinyCANf[^M
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param			Data : Mf[^
//-----------------------------------------------------------------------------
*/
int TinyCAN_Write (void )
{
	int i;

#ifdef mast
	/* Demo1.motp̑Mf[^ */
	
	*MD3_1 = 0x11;
	*MD3_2 = 0x22;
	*MD3_3 = 0x33;
	*MD3_4 = 0x44;
	*MD3_5 = 0x55;
	*MD3_6 = 0x66;
	*MD3_7 = 0x77;
	*MD3_8 = 0x88;
	
#else
	/* Demo2.motp̑Mf[^ */
	
	*MD3_1 = 0x01;
	*MD3_2 = 0x02;
	*MD3_3 = 0x04;
	*MD3_4 = 0x08;
	*MD3_5 = 0x10;
	*MD3_6 = 0x20;
	*MD3_7 = 0x40;
	*MD3_8 = 0x80;
	
#endif

	*TXPR |= 0x08;				/* MB3M҂ɐݒ */
	
	while( (*TXACK & 0x08 != 0x08) ){	/* MɂȂ܂Ń[v */
	}

	*TXACK |= 0x08;			/* MtÕNA */
	
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//TinyCAN_Read
//ETinyCANf[^M
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int TinyCAN_Read ( void )
{
	unsigned int i;

	while( ( *RXPR & 0x01 ) == 0 ){		/* MɂȂ܂Ń[v */
	}

	SCI_Print("\nTinyCAN_Read ");
	
	for(i=0;i<8 ;i++)
	{
		SCI_Print("\nMD0_");
		SCI_Print_Hex_Byte( i + 1 );
		SCI_Print(" ");
		SCI_Print_Hex_Byte( *( unsigned char* )( MD0_1 + i ) );
		Wait(20);
	}

	*RXPR |= 0x01;				/* MtÕNA */
	while( ( *RXPR & 0x01 ) != 0 ){		/* MtONA܂Ń|v */
	}

	for(i=0;i<8 ;i++)
	{
		*( MD0_1 + i ) = 0x00;		/* M{bNXf[^NA */
	}	
	
	return NOERROR;
}



/*
///////////////////////////////////////////////////////////////////////////////
//Init_LCD
//Ekbc
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Init_LCD ( void )
{
	/* ϐ */
	memset ( &m_LCDInfo, 0, sizeof ( TYPE_STRUCT_LCD ) );
	
	*PDR6 = 0x00;
	
	Wait_LCD ( 20 );
	
	*PDR6 = *PDR6 & ~0x04;	/* RS Low Set */

	/* LCD1 */
	*PDR6 = *PDR6 | 0x01;			/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/* MM1 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;			/* E Low Set */
	Wait_LCD ( 1 );
	
	Wait_LCD ( 5 );
	
	
	/* LCD2 */
	*PDR6 = *PDR6 | 0x01;			/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/* MM2 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;			/* E Low Set */
	Wait_LCD ( 1 );
	
	
	/* LCD3 */
	*PDR6 = *PDR6 | 0x01;			/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x30;	/* MM3 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;			/* E Low Set */
	Wait_LCD ( 1 );
	
	
	/* LCD4 */
	*PDR6 = *PDR6 | 0x01;			/* E High Set */
	*PDR6 = ( *PDR6 & 0x0f ) | 0x20;	/* MM4 */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;			/* E Low Set */
	Wait_LCD ( 1 );
	
	/* t@NVZbgFSrbgoXAQsAT~Vhbg */
	Write_LCD ( VAL_RS_LOW , 0x28 );
	
	/* Gg[[hFJ[\CNgAJ[\ړ */
	Write_LCD ( VAL_RS_LOW , 0x06 );

	/* J[\/\VtgFJ[\EVtg */
	Write_LCD ( VAL_RS_LOW , 0x10 );

	/* \ON/OFFRg[FfBXvC\AJ[\\AuN\ */
	Write_LCD ( VAL_RS_LOW , 0x0d );

	/* \NA */
	Clear_LCD ();
	
	Wait_LCD ( 5 );
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Clear_LCD
//@kbcF\NA
//-----------------------------------------------------------------------------
//return int
//	0	: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Clear_LCD ( void )
{
	*PDR6 = *PDR6 & ~0x04;			/* RS Low Set */
	Write_LCD ( VAL_RS_LOW , 0x01 );
	Wait_LCD ( 2 );
	Locate_LCD ( 0 , 0 );
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Locate_LCD
//@kbcFJ[\ړ
//-----------------------------------------------------------------------------
//return int
//	0	: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Locate_LCD ( const unsigned char X, const unsigned char Y )
{
	unsigned char i;
	i = Y * 0x40 + X;
	i = i | 0x80;
	
	Write_LCD( VAL_RS_LOW , i );
	Wait_LCD ( 1 );
	
	/* J[\ۑ */
	m_LCDInfo.CURSOR.BIT.X = X;
	m_LCDInfo.CURSOR.BIT.Y = Y;
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Print_LCD
//@kbcF\
//-----------------------------------------------------------------------------
//return int
//	0	: 
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Print_LCD ( const char *String )
{
	/* ϐ錾 */
	unsigned char i, j;
	
	
	/* \[v */
	for ( i = 0; String[ i ] != '\0'; ++i )
	{
		/* ` */
		if (
			( String[ i ] >= 0x20 && String[ i ] <= 0x7f ) ||
			( String[ i ] >= 0xa1 && String[ i ] <= 0xfd )
		)
		{/* kbcR[h͈͓̔̏ꍇ */
			/* ` */
			Write_LCD ( VAL_RS_HIGH, String[ i ] );
			Wait_LCD ( 1 );
			
			/* J[\ړ */
			if ( m_LCDInfo.CURSOR.BIT.X == VAL_LCD_ROW - 1 )
			{/* 16sI[o[ꍇ */
				m_LCDInfo.CURSOR.BIT.X = 0;
				m_LCDInfo.CURSOR.BIT.Y = ( m_LCDInfo.CURSOR.BIT.Y == 0 ? 1 : 0 );
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
				for ( j = 0; j < VAL_LCD_ROW; ++j )
					Write_LCD ( VAL_RS_HIGH, ' ' );
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			}
			else
			{/* 16sȓ̏ꍇ */
				++m_LCDInfo.CURSOR.BIT.X;
				Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			}/* if ( m_LCDInfo.CURSOR.BIT.X + 1 <= 0x0f ) */
		}
		else if ( String[ i ] == '\n' )
		{/* sR[h̏ꍇ */
			m_LCDInfo.CURSOR.BIT.X = 0;
			m_LCDInfo.CURSOR.BIT.Y = ( m_LCDInfo.CURSOR.BIT.Y == 0 ? 1 : 0 );
			Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
			for ( j = 0; j < VAL_LCD_ROW; ++j )
					Write_LCD ( VAL_RS_HIGH, ' ' );
			Locate_LCD ( m_LCDInfo.CURSOR.BIT.X, m_LCDInfo.CURSOR.BIT.Y );
		}
		else
		{/* kbcR[h͈̔͊Ȍꍇ */
			
		}/* if ( ( String[ i ] >= 0x21 && String[ i ] <= 0x7f ) || ( String[ i ] >= 0xa1 && String[ i ] <= 0xfd ) ) */
	}/* while ( String[ i ] != '\0' ) */
	
	
	/* I */
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Write_LCD
//@kbcF
//-----------------------------------------------------------------------------
//return int
//	0	: I
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int Write_LCD (
	const unsigned char RS_Mode ,
	const unsigned char Data
)
{
	/* 4rbg̏ꍇ */
	/* RS Setting */
	if ( RS_Mode == VAL_RS_LOW )
	{
		*PDR6 = *PDR6 & ~0x04;	/* RS Low Set */
	}
	else if ( RS_Mode == VAL_RS_HIGH )
	{
		*PDR6 = *PDR6 | 0x04 ;	/* RS High Set */
	}
	
	/* 4rbg */
	
	*PDR6 = *PDR6 | 0x01;	/* E High Set */
	
	*PDR6 = ( *PDR6 & 0x0f ) | ( Data & 0xf0 );	/* 4rbg */
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	/* 4rbg */
	*PDR6 = *PDR6 | 0x01;	/* E High Set */

	*PDR6 = ( *PDR6 & 0x0f ) | ( ( Data << 4 ) & 0xf0 );
	Wait_LCD ( 1 );
	*PDR6 = *PDR6 & ~0x01;	/* E Low Set */
	Wait_LCD ( 1 );
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Wait_LCD
//@kbcҋ@
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait_LCD ( const unsigned long Interval )
{
	volatile unsigned long i;
	for ( i = 0; i < Interval * 1000; ++i );
}

/*
///////////////////////////////////////////////////////////////////////////////
//SCI_Init
//Erbh
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
int SCI_Init( void )
{
	unsigned long i=0;

	*SCR3 = 0x00;
	*SMR = 0x00;
	*BRR = 0x40;		/*20MHz 9600bps*/

	Wait( 1 );

	*SCR3 = 0x30;
	*PMR1 = 0x0e;
	
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//SCI_Write
//EPoCgM
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param			data	: Mf[^
//-----------------------------------------------------------------------------
*/
int SCI_Write( const unsigned char data )
{
	while( !( *SSR & 0x80 ) ){
	}						/* TDRE׸ނPɂȂ܂Wait */
	*TDR = data;					/* Mް */
	while( !( *SSR & 0x04 ) ){
	}						/* TEND׸ނPɂȂ܂Wait */
	
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//SCI_Read
//EPoCgM
//-----------------------------------------------------------------------------
//return		code	: Mf[^
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
unsigned char SCI_Read( void )
{
	unsigned char code;

	while( !( *SSR & 0x78 ) ){
	}
	code = *RDR;
	*SSR = *SSR & ~0x78;

	return( code );
}

/*
///////////////////////////////////////////////////////////////////////////////
//SCI_Print
//EVAo
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param			*data	: 
//-----------------------------------------------------------------------------
*/
int SCI_Print( char *data )
{
	while( *data != '\0' )
	{				/* I[o */
		if( *data == '\n' )
		{			/* so */
			SCI_Write(0x0a);
			SCI_Write(0x0d);
		}
		else
		{					/* o */
			SCI_Write( *data );
		}
		data++;
	}
	
	return NOERROR;
}

/*
///////////////////////////////////////////////////////////////////////////////
//SCI_Print_Hex_Byte
//EoCggdwo
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param			data	: Mf[^
//-----------------------------------------------------------------------------
*/
int SCI_Print_Hex_Byte( const unsigned char data )
{
	const unsigned char disp_table[] = "0123456789ABCDEF";

	SCI_Write( disp_table[ ( data & 0xf0 ) >> 4 ] );
	SCI_Write( disp_table[ ( data & 0xf ) ] );
	
	return NOERROR;
}


/*
///////////////////////////////////////////////////////////////////////////////
//Wait
//Eԑ҂[v
//-----------------------------------------------------------------------------
//return
//-----------------------------------------------------------------------------
//param
//-----------------------------------------------------------------------------
*/
void Wait( const unsigned int msec )
{
	long i;
	for( i=0; i<1000 * ( long )msec; i++ ){
	}
}





#pragma section $DSEC
static const struct {
	void * rom_s;		/* f[^ZNVROM ̐擪AhX */
	void * rom_e;		/* f[^ZNVROM ̍ŏIAhX */
	void * ram_s;		/* f[^ZNVRAM ̐擪AhX */
}DTBL[]={
	{__sectop("D"), __secend ("D"), __sectop ("R")},
	{__sectop("$ABS8D"), __secend ("$ABS8D"), __sectop ("$ABS8R")},
	{__sectop("$ABS16D"), __secend ("$ABS16D"), __sectop ("$ABS16R")}
};
#pragma section $BSEC
static const struct {
	void * b_s;		/* f[^ZNV̐擪AhX */
	void * b_e;		/* f[^ZNV̍ŏIAhX */
}BTBL[]={
	{__sectop("B"), __secend("B")},
	{__sectop("$ABS8B"), __secend("$ABS8B")},
	{__sectop("$ABS16B"), __secend("$ABS16B")}
};
